summaryrefslogtreecommitdiffstats
path: root/source/xfce/exo
diff options
context:
space:
mode:
Diffstat (limited to 'source/xfce/exo')
-rwxr-xr-xsource/xfce/exo/exo.SlackBuild8
-rw-r--r--source/xfce/exo/exo.magnet.uri.diff49
2 files changed, 55 insertions, 2 deletions
diff --git a/source/xfce/exo/exo.SlackBuild b/source/xfce/exo/exo.SlackBuild
index a3189a584..efb86758a 100755
--- a/source/xfce/exo/exo.SlackBuild
+++ b/source/xfce/exo/exo.SlackBuild
@@ -1,6 +1,6 @@
#!/bin/sh
-# Copyright 2012 Patrick J. Volkerding, Sebeka, Minnesota, USA
+# Copyright 2012, 2013 Patrick J. Volkerding, Sebeka, Minnesota, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -22,7 +22,7 @@
PKGNAM=exo
VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z* | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
-BUILD=${BUILD:-1}
+BUILD=${BUILD:-2}
# Automatically determine the architecture we're building on:
MARCH=$( uname -m )
@@ -64,6 +64,10 @@ rm -rf $PKGNAM-$VERSION
tar xvf $CWD/$PKGNAM-$VERSION.tar.?z* || exit 1
cd $PKGNAM-$VERSION || exit 1
+zcat $CWD/exo.magnet.uri.diff.gz | patch -p1 --verbose || exit 1
+
+find . -exec touch {} \;
+
chown -R root:root .
find . \
\( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff --git a/source/xfce/exo/exo.magnet.uri.diff b/source/xfce/exo/exo.magnet.uri.diff
new file mode 100644
index 000000000..336ca2121
--- /dev/null
+++ b/source/xfce/exo/exo.magnet.uri.diff
@@ -0,0 +1,49 @@
+From 05848bb3cb10ea19ef8cba607bdabcd25560063c Mon Sep 17 00:00:00 2001
+From: Felipe Contreras <felipe.contreras@gmail.com>
+Date: Sun, 19 May 2013 03:50:01 +0000
+Subject: Fix exo_str_looks_like_an_uri() (bug #10098).
+
+Commit d11199b (Check if uris also contain a slash (bug #9244)) tried to
+fix a hang in thunar by properly recognizing that 'http:' is not an URI,
+however, while doing so, it broke proper URIs like 'magnet:foo'.
+
+As the RFC clearly states:
+
+ The following are two example URIs and their component parts:
+
+ foo://example.com:8042/over/there?name=ferret#nose
+ \_/ \______________/\_________/ \_________/ \__/
+ | | | | |
+ scheme authority path query fragment
+ | _____________________|__
+ / \ / \
+ urn:example:animal:ferret:nose
+
+But even with this succinct example exo_str_looks_like_an_uri() fails.
+
+There is an easy solution; fail only when component part is missing
+('urn:'), but succeed otherwise.
+
+This solution fixes 'magnet:foo', and doesn't break the current
+expectation from thunar that 'http:' should fail, having the best of
+both worlds.
+
+[1] http://www.ietf.org/rfc/rfc3986.txt
+
+Signed-off-by: Felipe Contreras <felipe.contreras@gmail.com>
+---
+diff --git a/exo/exo-string.c b/exo/exo-string.c
+index 33f86f9..056b36a 100644
+--- a/exo/exo-string.c
++++ b/exo/exo-string.c
+@@ -429,7 +429,7 @@ exo_str_looks_like_an_uri (const gchar *str)
+ for (++s; g_ascii_isalnum (*s) || *s == '+' || *s == '-' || *s == '.'; ++s);
+
+ /* <scheme> must be followed by ":" */
+- return (*s == ':' && *(s+1) == '/');
++ return (*s == ':' && *(s+1) != '\0');
+ }
+
+ return FALSE;
+--
+cgit v0.9.2